﻿@page "/adduser"
@inject NavigationManager NavigationManager
@inject HttpClient _httpClient
@inject IJSRuntime _jsRuntime
@inject ILogger<Login> Logger
@inject CustomAuthenticationStateProvider AuthStateProvider
@layout AdduserLayout

<MudGrid Justify="Justify.Center">
    <MudItem xs="12" sm="8" md="6" lg="4" xl="3">
        <MudPaper Elevation="8" Class="pa-4">
            <MudTabs>
                <MudTabPanel Text="Register">
                    <MudText Typo="Typo.h5" Class="pt-3 pb-1.5" GutterBottom="true">Register</MudText>
                    <MudForm @ref="registerForm" @bind-IsValid="isRegisterValid" Class="ga-2">
                        <MudTextField Label="First Name" Variant="Variant.Filled" @bind-Value="registerModel.FirstName" Required="true" RequiredError="First Name is required!" FullWidth />
                        <MudTextField Label="Last Name" Variant="Variant.Filled" @bind-Value="registerModel.LastName" Required="true" RequiredError="Last Name is required!" FullWidth />
                        <MudTextField Label="Email" Variant="Variant.Filled" @bind-Value="registerModel.Email" Required="true" RequiredError="Email is required!" FullWidth />
                        <MudTextField Label="Password" Variant="Variant.Filled" @bind-Value="registerModel.Password" Required="true" RequiredError="Password is required!" InputType="InputType.Password" FullWidth />
                        <MudButton Variant="Variant.Filled" Color="Color.Primary" Class="mt-4" OnClick="HandleRegister">Register</MudButton>
                    </MudForm>
                    @if (registerFailed)
                    {
                        <MudAlert Severity="Severity.Error" Class="mt-4">@registerErrorMessage</MudAlert>
                    }
                </MudTabPanel>
            </MudTabs>
        </MudPaper>
    </MudItem>
</MudGrid>

@code {
    private MudForm form;
    private MudForm registerForm;
    private PostAuthenticationRequestModel loginModel = new PostAuthenticationRequestModel();
    private PostUserModel registerModel = new PostUserModel();
    private bool loginFailed;
    private bool registerFailed;
    private bool isValid;
    private bool isRegisterValid;
    private string registerErrorMessage = "Registration failed, please try again.";

    private async Task HandleRegister()
    {
        registerFailed = false;
        await registerForm.Validate();

        if (isRegisterValid)
        {
            var success = await RegisterAsync(registerModel);
            if (success)
            {
                List<GetUserModel> users = await _httpClient.GetFromJsonAsync<List<GetUserModel>>("/api/Users");
                if (users.Count() == 1)
                {
                    NavigationManager.NavigateTo("/login");
                }
                else
                {
                    NavigationManager.NavigateTo("/adduser");
                }
            }
            else
            {
                registerFailed = true;
                registerErrorMessage = "Registration failed, please try again.";
            }
        }
    }

    public async Task<bool> RegisterAsync(PostUserModel registerModel)
    {
        var response = await _httpClient.PostAsJsonAsync("/api/Users", registerModel);
        if (response.IsSuccessStatusCode)
        {
            return true;
        }
        else
        {
            var responseContent = await response.Content.ReadAsStringAsync();
            Logger.LogError("Registration failed with HTTP status {Status}: {Content}", response.StatusCode, responseContent);
            return false;
        }
    }
}
